// Description:
//		Redirects the guest based on their
// 		useragent in conjunction with a mobile device rule
// 		set defined within a site specific config file
//


//set the value of each device to blank value - later to be overwritten with value retrieved from config file
var aNoIphone = [''];
var aNoIpad = [''];
var aNoWap = [''];

var iPhoneRedirectUrl = "";
var iPadRedirectUrl = "";
var wapRedirectUrl = "";

// gets the useragent & sets the var theUserAgent
var theUserAgent = navigator.userAgent.toLowerCase();

// need to check for 'updat' to avoid a false positive on 'pda'
// no match on 'updat' lets the script move on to the device detection
if (theUserAgent.indexOf('updat') == -1) {

	// sets the complete list of supported devices in 3 different groups
	// Global iPhone/iPod list
	var iphone = ((theUserAgent.indexOf('iphone') != -1) || (theUserAgent.indexOf('ipod') != -1));

	// Detect for image preview
	var gwp = (theUserAgent.indexOf('google web preview') > -1);

	// Global iPad list
	var ipad = (theUserAgent.indexOf('ipad') > -1);


	// Global WAP list
	var wap = ['android', 'avantgo', 'behold', 'blackberry', 'blackberry9330', 'blackberry9550', 'blackberry9330/5.0.0.913', 'blackberry9550/5.0.0.320', 'blazer', 'build/frg83g', 'comet', 'droid', 'elaine', 'hero', 'hiptop', 'htc-a6366', 'iemobile', 'kindle', 'lg-c900', 'lg-ms690', 'lg-p999', 'midp', 'mmp', 'mobile', 'Mobile Safari/533.1', 'motorola_i1', 'mytouch4g', 'nexus', 'novarra', 'o2', 'opus', 'palm', 'pda', 'pixi', 'pixi/1.0', 'pixi/1.1', 'plucker', 'pocket', 'psp', 'samsung', 'sch-r910', 'sgh-i917', 'smartphone', 'sph-m900', 'sph-m910', 'sph-t939','symbian', 't8788', 'treo', 'vendorid/104', 'vendorid/105', 'VendorID/106', 'vendorid/109', 'vendorid/126', 'vendorid/179', 'vendorid/189', 'vendorid/205', 'vendorid/236', 'vendorid/248', 'vendorid/269', 'vendorid/294', 'vendorid/315', 'vendorid/389', 'vodafone', 'vortex', 'vs750', 'wap',  'xiino' ];


	// define varible for config and create new object from querystring
	var config = document.getElementById("mobileSite").src.toLowerCase();

	
	// creates object and parses querystring
	function QSParser(config){
		//Create regular expression object to retrieve the qs part
		var qsReg = new RegExp("[?][^#]*","i");
		var hRef = unescape(config);
		var qsMatch = hRef.match(qsReg);

		//removes the question mark from the url
		qsMatch = new String(qsMatch);
		qsMatch = qsMatch.substr(1, qsMatch.length -1);

		//split it up
		var rootArr = qsMatch.split("&");

		for(i=0;i<rootArr.length;i++){
			var tempArr = rootArr[i].split("=");
			if(tempArr.length ==2){
				tempArr[0] = unescape(tempArr[0]);
				tempArr[1] = unescape(tempArr[1]);
		
				this[tempArr[0]]= tempArr[1];
			}
		}
	}
	
	
	// sources in the config file values
	function getConfigValuesJS(qs){

		mdFilename = 'http://a.dolimg.com/en-US/disneymobile/global/js/globalMobileDetectConfigs/' + qs.config + '.js';
		
		var oHead = document.getElementsByTagName('head')[0];
		
		oScript = document.createElement('script');
		oScript.src = mdFilename;
		oScript.type = 'text/javascript';
		oHead.appendChild(oScript);
		
		gwpChecker();

	}
	
	
	function gwpChecker() {	
		if (iPhoneRedirectUrl != "") {
			if (!gwp) {
				redirectToUrl();
				return;
			} else if (gwp && iphone) {
				redirectToUrl();
				return;
			}
		} else {
			setTimeout("gwpChecker()", 10);
		}
	}

	
	// checks the config for which devices to ignore & sets the redirect
	function redirectToUrl() {

		// sets the redirect check to false
		var isRedirected = false;

		// if it's iphone, redirect & exit
		for (noIphone in aNoIphone){
			if (iphone && noIphone != iphone) {
				document.location.replace(iPhoneRedirectUrl);
				isRedirected = true;
			}
			if (isRedirected) {break;}
		}

		// if it's ipad, redirect & exit
		for (noIpad in aNoIpad) {
			if (ipad && noIpad != ipad) {
				document.location.replace(iPadRedirectUrl);
				isRedirected = true;
			}
			if (isRedirected) {break;}
		}

		// check to see if the redirect already fired
		if (isRedirected == false) {

			// cycles through the global WAP list
			for (yesWapIndex in wap){
				var isSet = false;

				// cycles through the no-fly list
				for (noWapIndex in aNoWap) {

					// Is my user agent contained in the global WAP list?
					// AND is my user agent on the no-fly list?
					// If yes for both, you get booted out of this loop & then out of its parent loop
					// ultimately exiting the function without redirecting to anything.
					if ((theUserAgent.indexOf(wap[yesWapIndex]) != -1) && (wap[yesWapIndex] == aNoWap[noWapIndex])) {
						isSet = true;
						break;

					// If my user agent matched one in the global WAP list, set the redirect to fire
					} else if (theUserAgent.indexOf(wap[yesWapIndex]) != -1) {
						isRedirected = true;
					}
				}

				// if this value gets set, you get booted from this loop
				if (isSet) {break;}
			}

			// if my user agent matched one in the global WAP list
			// AND didnt match whats in the no-fly list, then redirect
			if (isRedirected && !isSet) {
				document.location.replace(wapRedirectUrl);
			}
		}
	}
	
	
	// gets the config name from the script tag
	var qs = new QSParser(config);
	
	// goes out & gets all of the redirect URLs from the custom config
	getConfigValuesJS(qs);
	
}
